! $Id: ext2boot.h,v 1.2 1994/06/25 12:27:18 root Exp $
!--------------------------------------------------------------------
!
! Package supporting Linux booting from Second Extended Filesystem.
! This file can be redistributed under the terms of the GNU General
! Public License
!
!			Copyright (c) 1994, Rafal Pietrak.
!
!--------------------------------------------------------------------
!
#include <linux/config.h>
!
! now import common BOOT definitions
!
#include "fsboot.h"
!
!--------------------------------------------------------------------

EXT2_ROOT_INO		= 2
EXT2_BOOT_LOADER_INO	= 5

EXT2_FIRST_DATA_BLOCK = 0x14		! ext2fs superblock structure offsets
EXT2_BLOCKS_PER_GROUP = 0x20
EXT2_INODES_PER_GROUP = 0x28
EXT2_MAGIC = 0x38

EXT2_DIR_INODE = 0
EXT2_DIR_RECLEN = 4
EXT2_DIR_NAMLEN = 6
EXT2_DIR_NAME = 8

EXT2GR_INODE_TABLE	= 8		! offset to information abount inode table
					! in the group description block
EXT2IN_I_SIZE		=    4		! ext2fs 
EXT2IN_I_BLOCKS		= 0x1c		! ext2fs 
EXT2IN_BLOCK		= 0x28		! ext2fs inode structure offset

SIZEOF_FS_BLOCK_SHIFT	= 1	! shift_1 == sectors_2; shift_2 == sectors_4, ....
SIZEOF_FS_BLOCK_SECTORS	= 2	!    this depend on line above...
SIZEOF_SECTOR_BITS	= 9
SIZEOF_SECTOR		= 512

SIZEOF_FS_BLOCK		= SIZEOF_SECTOR * SIZEOF_FS_BLOCK_SECTORS
SIZEOF_FS_BLOCK_PAR	= SIZEOF_FS_BLOCK / 16
SIZEOF_STRUCT_INODE	= 0x80
SIZEOF_FS_BLOCK_BITS	= SIZEOF_FS_BLOCK_SHIFT + SIZEOF_SECTOR_BITS
INODES_PER_BLOCK	= SIZEOF_FS_BLOCK / SIZEOF_STRUCT_INODE

!
! constants used for locating file block based on the information
! found in inode structure.
!
INDIRECT_0	= 12
INDIRECT_1	= 12 + 256
INDIRECT_2	= 12 + 256 * 257
INDIRECT_3	= 12 + 256 * 257 + 256 * 256 * 256
LOC_IND_0	= 4 * INDIRECT_0
LOC_IND_1	= 4 * INDIRECT_1
LOC_IND_2	= 4 * INDIRECT_2
LOC_IND_3	= 4 * INDIRECT_3
LOC_IND_01	= LOC_IND_0 + 4
LOC_IND_02	= LOC_IND_0 + 8

