! $Id: fsboot.h,v 1.3 1994/07/04 19:06:36 root Exp root $
!--------------------------------------------------------------------
!
! Package supporting Linux booting from Second Extended Filesystem.
! This file can be redistributed under the terms of the GNU General
! Public License
!
!			Copyright (c) 1994, Rafal Pietrak.
!
!--------------------------------------------------------------------

.text

.globl	boot_input
.globl	get_inode
.globl	file_block
.globl	print_si
.globl	load_block
.globl	load_file
.globl	msg_nofs
.globl	load_indirect0
.globl	load_indirect1
.globl	setup_begin
.globl	flush
.globl	gettime

SETUPSECS = 4				! nr of setup-sectors
BOOTSEG   = 0x07C0			! original address of boot-sector
INITSEG   = DEF_INITSEG			! we move boot here - out of the way
!INITSEG   = 0x8000			! we move boot here - out of the way
SETUPSEG  = DEF_SETUPSEG		! setup starts here
SYSSEG    = DEF_SYSSEG			! system loaded at 0x10000 (65536).

!--------------------------------------------------------------------

#define CL_MAGIC	0xA33F
#define CL_BASE_ADDR	0x90000

#define CL_MAGIC_ADDR	0x90020-CL_BASE_ADDR
#define CL_OFFSET	0x90022-CL_BASE_ADDR

!--------------------------------------------------------------------

VAR_DISK		=    0
VAR_SECT		=    2
VAR_SECTORS_TRACK	=    4
VAR_SECTORS_CYL		=    8
VAR_PARTITION		= 0x0c

VAR_FIRST_DATA_BLOCK	= 0x10
VAR_BLOCKS_PER_GROUP	= 0x14
VAR_INODES_PER_GROUP	= 0x18
VAR_GROUP_ORIG_BLOCK	= 0x1c
VAR_NSTACK		= 0x20		! 2 bytes
VAR_DIR_ACTION		= 0x22		! 2 bytes
VAR_CURDIR_INODE	= 0x24
VAR_CUROPN_INODE	= 0x28
VAR_ROOT_DEV		= 0x2c		! 2 bytes

VAR_INODE_CACHE		= 0x30
VAR_INODE1_CACHE	= 0x34
VAR_BLOCK_CACHE		= 0x38
VAR_FS_BLOCK_SIZE	= 0x3c		! (2 bytes) for futur 'dynamic' block size.

VAR_FILE_CURBLOCK	= 0x40
VAR_FILE_PTR		= 0x44		! (2 bytes) level to which BUFF_BLOCK is feeled
VAR_BUFF_REMAIN		= 0x46		! (2 bytes) remaining *valid* bytes in BUFF_BLOCK
VAR_ENV_TAIL		= 0x48		! (2 bytes)
VAR_SEARCH_TARGET	= 0x4a		! (2 bytes)

VAR_CURRENT_INODE	= 0x50		! area SIZEOF_INODE_STRUCT (i.e. 0x80 bytes)

VAR_GETS_INPUT		= 0x0100	! command input area

BUFF_LOCAL_VAR		= 0x8000
BUFF_BOOT_ENV		= 0x9000	! 4k boot environement and...
BUFF_NAME_STACK		= 0x9000	! ...4k stack of names for directory lookup
BUFF_INODE1		= 0xa000	! 8k area
BUFF_INODE		= 0xc000	! 8k area
BUFF_BLOCK		= 0xe000	! 8k area (fs blocks have to be that size, at most)

BUFF_NAME_STACK_END	= BUFF_INODE1
BUFF_BOOT_ENV_END	= BUFF_NAME_STACK_END
PTR_NSTACK_INIT		= BUFF_NAME_STACK_END - 2

ROOT_DEV = 0			! ROOT_DEV is now handled automaticaly
SWAP_DEV = 0			! SWAP_DEV is no longer used
#ifndef SVGA_MODE
#define SVGA_MODE ASK_VGA
#endif
#ifndef RAMDISK
#define RAMDISK 0
#endif 
#ifndef CONFIG_ROOT_RDONLY
#define CONFIG_ROOT_RDONLY 0
#endif

OMAGIC = 0407
NMAGIC = 0410
ZMAGIC = 0413
QMAGIC = 0314
CMAGIC = 0421
