/* $Id: ib.c,v 1.1 1994/07/04 19:08:24 root Exp root $ */
/*
  Package supporting Linux booting from Second Extended Filesystem
  (largely based on code from rdev.c).

  This file can be redistributed under the terms of the GNU General
  Public License
 
 			Copyright (c) 1994, Rafal Pietrak.
 */

#include <stdio.h>
#include <fcntl.h>
#include <linux/ext2_fs.h>
#include <sys/stat.h>

#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

void * malloc(int size);

void die(char *s);

static char *find_dev(int number);



int fs_handle;

void die(char *s)
{
	perror(s);
	exit(1);
}

#define DEFAULT_OFFSET 508

char device_name[PATH_MAX+1];

static char *find_dev(int number)
{
    DIR *dp;
    struct dirent *dir;
    struct stat s;

    if (!number) return "Boot device";
    if ((dp = opendir("/dev")) == NULL) die("opendir /dev");
    strcpy(device_name,"/dev/");
    while (dir = readdir(dp)) {
	strcpy(device_name+5,dir->d_name);
	if (stat(device_name,&s) < 0) die(device_name);
	if ((s.st_mode & S_IFMT) == S_IFBLK && s.st_rdev == number) return device_name;
    }
    sprintf(device_name,"0x%04x",number);
    return device_name;
}

main(int ac, char *av[], char *ev[])
{	struct stat  sbf;
	char *p;
	int	new_bino;

	if (ac < 2)
	{
		fprintf(stderr, "usage: %s <file>\n", av[0]);
		exit(1);
	}

	if (stat(av[1], &sbf) < 0)
	{
		fprintf(stderr, "cannot stat: %s\n", av[1]);
		exit(1);
	} else
		p = av[1];

	printf("%s:%d\n", find_dev(sbf.st_dev), sbf.st_ino);

	new_bino = sbf.st_ino;

	if (sbf.st_ino == EXT2_BOOT_LOADER_INO)
	{	fprintf(stderr, "File %s is already installed as boot.\n", p);
		exit(1);
	}

	fs_handle = open(av[1], O_RDWR  , -1);
	if (fs_handle < 0)
	{	fprintf(stderr, "cannot open file %s\n", device_name);
		exit(1);
	}

	lseek(fs_handle, 506, SEEK_SET);
	write(fs_handle, &sbf.st_ino, 4);


	close(fs_handle);
	exit(0);
}

